﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using IDTechSDK;

namespace USDKDemo
{
    public partial class Decrypt : Form
    {
        public Decrypt()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (tBDK.Text.Length != 32)
            {
                tResults.Text = "BDK Error";
                return;
            }
            if (tKSN.Text.Length == 0)
            {
                tResults.Text = "Missing KSN";
                return;
            }
            if (tEncryptedData.Text.Length == 0)
            {
                tResults.Text = "Missing Encrypted Data";
                return;
            }
            int type = 1; if (aes.Checked) type = 2;
            byte[] decrypt = IDTTransactionData.decryptData(aes.Checked, Common.getByteArray(tKSN.Text), tBDK.Text, Common.getByteArray(tEncryptedData.Text));
            if (decrypt != null && decrypt.Length > 0)
            {
                tResults.Text = Common.getHexStringFromBytes(decrypt) + "\r\n\r\n" + System.Text.Encoding.UTF8.GetString(decrypt) ;
            }
            else
            {
                tResults.Text = "Decrypt Error";
            }
        }
    }
}
